package space.anyi.BI.config;

import io.netty.util.concurrent.CompleteFuture;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;
import java.util.concurrent.ThreadPoolExecutor;

import static org.junit.jupiter.api.Assertions.*;

/**
 * @ProjectName: serve
 * @FileName: ThreadPoolExecutorConfigTest
 * @Author: 杨逸
 * @Data:2024/12/7 16:13
 * @Description:
 */
@SpringBootTest
class ThreadPoolExecutorConfigTest {
    @Resource
    private ThreadPoolExecutor threadPoolExecutor;

    @Test
    void getThreadPoolExecutor() throws InterruptedException {
        final int[] count = {1};
        //创建一个任务
        Runnable runnable = new Runnable() {
            @Override
            public void run() {
                System.out.println("线程池执行任务" + count[0]++);
                try {
                    Thread.sleep(1000*2);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        };
        //使用线程池执行任务
        for (int i = 0; i < 7; i++) {
            threadPoolExecutor.execute(runnable);
        }
        //工作的线程数
        Assertions.assertEquals(2, threadPoolExecutor.getActiveCount());
        //工作的最大线程数
        Assertions.assertEquals(2, threadPoolExecutor.getMaximumPoolSize());
        //任务队列大小
        Assertions.assertEquals(5, threadPoolExecutor.getQueue().size());
        //经过线程池的任务数量
        Assertions.assertEquals(7, threadPoolExecutor.getTaskCount());
        //休眠一下,让任务执行完成
        Thread.sleep(1000*17);
    }
}
